/*
	BPMApp.cpp:		Application class for BePhotoMagic
*/

#include "BPMApp.h"
#include <stdio.h>
#include <stdlib.h>
#include <Roster.h>
#include <Entry.h>
#include <Path.h>
#include "TileVMM.h"
#include "TileCache.h"
#include "TileManager.h"
#include "Tile.h"
#include <String.h>

extern TileVMM *global_tile_vmm;

BString apppath;

void GetAppFolder(BString *string)
{
	if(!string)
		return;
	
	// Find out the app's path
	app_info ai;
	BPath path;
	
	be_app->GetAppInfo(&ai);
	BEntry entry(&(ai.ref));
	BEntry parent;
	entry.GetParent(&parent);
	parent.GetPath(&path);

	string->SetTo(path.Path());
}

BPMApp::BPMApp(void)
 : BApplication("application/x-vnd.bpm-BePhotoMagic")
{
}

BPMApp::~BPMApp(void)
{
}

int main(void)
{
	BPMApp app;
	
	GetAppFolder(&apppath);
	
	// Rather than doing it the hard way, we'll just make a quick
	// call to the shell to remove any temp files which already exist
	printf("Removing temp files...\n");

	BString rmcmd(apppath.String());
	rmcmd.CharacterEscape(" ",'\\');
	rmcmd.Prepend("rm -f ");
	rmcmd+="/BPMTempFile* > /dev/null";
	system(rmcmd.String());
	
	
	// Start up the whole tile memory management subsystem
	global_tile_vmm=new TileVMM(apppath.String());

	TileManager manager(1000,1000,4);
	Tile *tile;
		
	for(int32 i=0; i<10; i++)
	{
		tile=manager.GetTile(i,TILE_READ_ONLY);
	}


	delete global_tile_vmm;

}
