#ifndef BPMVIEW_H_
#define BPMVIEW_H_

#include <View.h>
#include <Bitmap.h>
#include <Message.h>

/*
	The general concept behind BPMView is one big view to represent the entire work area
	in which the image is displayed. This will allow for easy (and relatively fast) 
	display via a BBitmap, really useful and nice-looking cursors which can be loaded 
	from disk or from resources, and other cool stuff like drag-and-drop background color
	changes and graphics rulers and such.
*/
class BPMView : public BView
{
public:
	BPMView(BRect frame, const char *name, int32 resize, int32 flags);
	virtual ~BPMView(void);
	virtual void Draw(BRect update);
	virtual void MessageReceived(BMessage *msg);
	virtual void MouseDown(BPoint pt);
	virtual void MouseMoved(BPoint pt, uint32 transit, const BMessage *dragmsg);
	virtual void MouseUp(BPoint pt);

private:
	BBitmap *display,*cursor;
	BRect imgrect, cursorrect, oldcursorrect;
	rgb_color backcolor;
};

#endif
