#ifndef GAPLIST_H
#define GAPLIST_H

#include <SupportDefs.h>

class Gap;

class GapList
{
public:
	GapList(const uint64 &startingsize);
	~GapList(void);

	status_t Get(const uint32 &size, uint64 &position);

	void Add(const uint64 &start, const uint64 &end);
	void Expand(const uint64 &size);
	void Truncate(const uint64 &size);
	
	status_t SeeFirst(uint64 &position) const;
	status_t SeeLast(uint64 &position) const;
	status_t SeeItem(const uint32 &index, uint64 &position) const;
	
	uint32 CountItems(void) const { return itemcount; }
	
protected:
	void RemoveItem(Gap *gap);
	Gap *head;
	Gap *tail;
	uint32 itemcount;
	uint64 poolsize;
};


#endif
