/*
	LinkList.cpp:	Quick-and-dirty doubly-linked list classes
*/
#include <SupportDefs.h>
#include "LinkList.h"

LinkListItem::LinkListItem(void)
{
	head=this;
	prev=NULL;
	next=NULL;
}

void LinkListItem::Append(LinkListItem *item)
{
	// Append the item to the end of the list

	if(!item)
		return;
	
	// Get the tail item
	LinkListItem *tail=next;
	
	if(tail)
	{
		while(tail->next)
			tail=tail->next;
	}
	else
		tail=this;
	
	// this item is the tail, so tack it on at the end
	item->prev=tail;
	tail->next=item;
	item->head=tail->head;
}

void LinkListItem::Prepend(LinkListItem *item)
{
	if(!item)
		return;
	
	item->prev=NULL;
	item->next=this;
	item->head=item;
	
	// Set the head item for all items in the list
	LinkListItem *listhead=item;
	while(listhead->next)
	{
		listhead=listhead->next;
		listhead->head=item;
	}
}

void LinkListItem::RemoveSelf(void)
{
	head=this;

	if(next)
		next->prev=prev;

	if(prev)
		prev->next=next;
	else
	{
		// prev is NULL, so we must be at the head of the list. The rest of the items
		// need their pointer updated

		LinkListItem *listhead=this;
		while(listhead->next)
		{
			listhead=listhead->next;
			listhead->head=next;
		}
		
	}
}
