#ifndef TILECACHE_H_
#define TILECACHE_H_

#include <OS.h>
#include <List.h>
#include <Locker.h>

#include "Tile.h"
#include "TileList.h"

class TileVMM;

// TODO: Find out what a good size would be
#define DEFAULT_CACHE_SIZE 65536

class TileCache : public BLocker
{
public:
	TileCache(void);
	~TileCache(void);

	void SetMaxSize(uint64 size);
	uint64 GetMaxSize(void) const { return maxsize; }
	uint64 GetSize(void) const { return currentsize; }
	
	bool TileWillFit(void);
	status_t AddTile(Tile *tile);
	status_t FlushTile(Tile *tile);
	Tile *GetOldestTile(void);
	bool HasTile(Tile *tile);
	Tile *GetTile(int32 tileid);
protected:
	TileList tilelist;

	uint64 currentsize,maxsize;
	TileVMM *vmm;
};

uint64 get_default_cache_size(void);
void set_default_cache_size(uint64 size);

#endif
