#ifndef TILELIST_H_
#define TILELIST_H_

#include <SupportDefs.h>

class Tile;

class TileListItem
{
public:
	TileListItem(Tile *tdata, TileListItem *tnext) { data=tdata; next=tnext; }
	TileListItem *next;
	Tile *data;
};

class TileList
{
public:
	TileList(void);
	~TileList(void);
	void Add(Tile *tile);
	void Remove(int32 tileid);
	Tile *Get(int32 tileid);
	Tile *GetOldest(void);
	int32 CountItems(void) const { return itemcount; }
protected:
	TileListItem *head;
	int32 itemcount;
};

#endif
