#include "HWindow.h"
#include "HApp.h"

#include <MenuItem.h>
#include <MenuBar.h>
#include <Beep.h>
#include <ClassInfo.h>
#include <stdio.h>
#include <InterfaceDefs.h>
#include "ComboBox.h"

/***********************************************************
 * Constructor
 ***********************************************************/
HWindow::HWindow(BRect rect ,const char* name)
	:BWindow(rect,name,B_DOCUMENT_WINDOW,0)
{
	InitMenu();
	InitGUI();
}

/***********************************************************
 * Destructor
 ***********************************************************/
HWindow::~HWindow()
{

}

/***********************************************************
 * InitGUI
 ***********************************************************/
void
HWindow::InitGUI()
{
	BView *view = new BView(Bounds(),NULL,B_FOLLOW_ALL,B_WILL_DRAW);
	view->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	AddChild(view);
	
	BRect rect;
	rect.top = 100;
	rect.bottom = rect.top + 30;
	rect.left = 10;
	rect.right = rect.left + 200;
	ComboBox *combo = new ComboBox(rect,NULL,"Combo:",NULL,NULL,5);
	view->AddChild(combo);
	combo->SetDivider(combo->StringWidth("Combo:")+1);
	char name[] = "test1";
	for(int32 i = 0;i < 9;i++)
	{
		combo->AddItem(name);
		name[4]++;
	}
}

/***********************************************************
 * InitMenu
 ***********************************************************/
void
HWindow::InitMenu()
{
	BMenuBar *menuBar = new BMenuBar(Bounds(),"MENUBAR");
	BMenu *menu;
	BMenuItem *item;
	
	menu = new BMenu("File");
	item = new BMenuItem("test",NULL,'M',0);
	menu->AddItem(item);
	menuBar->AddItem(menu);
	this->AddChild(menuBar);
}

/***********************************************************
 * QuitRequested
 ***********************************************************/
bool
HWindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return BWindow::QuitRequested();
}
