#ifndef __FLYOUTBOX_H__
#define __FLYOUTBOX_H__

#include <Window.h>
#include <View.h>
#include <Invoker.h>
#include <MessageFilter.h>
#include <Box.h>
#include <String.h>

class FlyoutWindow;

class FlyoutFilter :public BMessageFilter
{
public:
	FlyoutFilter(BView *view,message_delivery delivery,
			message_source source);
	virtual	~FlyoutFilter();		
	
	BView *View(){return fView;}
private:
	virtual filter_result Filter(BMessage *message, BHandler **target);
	BView *fView;
};

class FlyoutBox : public BBox ,public BInvoker
{
public:
	FlyoutBox(BRect rect,const char* name,const char *wintitle,
			uint32 resize = B_FOLLOW_LEFT | B_FOLLOW_TOP,
			uint32 flags = B_WILL_DRAW);
	virtual ~FlyoutBox(void);
		
	virtual	void AttachedToWindow(void);
	virtual void DetachedFromWindow(void);
	
	void AddDisplayView(BView *view);
	BView *RemoveDisplayView(void);
	void AddWindowView(BView *view);
	BView *RemoveWindowView(void);
	
	BPicture *MakeUpStatePicture(void);
	BPicture *MakeDownStatePicture(void);
		
	void SetWindowNULL(void);
	void SetTitle(const char *title);
	void ShowList(void);
	void HideList(void);
	virtual	void KeyDown(const char* bytes,int32 numBytes);
	void SetEnabled(bool enable=true);
	
protected:
	virtual void MessageReceived(BMessage *message);
	
private:
	FlyoutWindow *fSubsetWindow;
	int32 fDisplayCount;
	int32 fCurrentIndex;
	FlyoutFilter *fMessageFilter;
	bool fFlagsChanged;
	
	BView *displayview, *windowview;
	BString windowtitle;
};
#endif