#include "FlyoutFilter.h"
#include "FlyoutBox.h"

#include <Message.h>
#include <Debug.h>

FlyoutFilter::FlyoutFilter(BView *view,
	message_delivery delivery,message_source source)
: BMessageFilter(delivery,source),
	fView(view)
{

}

FlyoutFilter::~FlyoutFilter(void)
{
}

filter_result FlyoutFilter::Filter(BMessage *message,BHandler **target)
{
	switch(message->what)
	{
		case B_MOUSE_DOWN:
		{
				BView *view = fView->FindView("_PictureButton");
				if(view != *target)
					((FlyoutBox*)fView)->HideList();
				break;
		}
		case B_KEY_DOWN:
		{
			const char* bytes;
			message->FindString("bytes",&bytes);
			if(bytes[0] == B_UP_ARROW || bytes[0] == B_DOWN_ARROW)
			{
				((FlyoutBox*)fView)->KeyDown(bytes,1);
				return B_SKIP_MESSAGE;
			}
			break;
		}
		default:
		{
			break;
		}
	}
	return B_DISPATCH_MESSAGE;
}