#include "FlyoutWindow.h"
#include "FlyoutBox.h"

FlyoutWindow::FlyoutWindow(BRect rect,const char *title,BView *view,FlyoutBox *target)
		:BWindow(rect,title, 
				B_FLOATING_WINDOW_LOOK,B_FLOATING_APP_WINDOW_FEEL,
				B_AVOID_FOCUS | B_NOT_MOVABLE | B_WILL_ACCEPT_FIRST_CLICK |
				B_NOT_ZOOMABLE | B_NOT_RESIZABLE | B_NOT_MINIMIZABLE),
		childview(view),
		fTarget(target)
{
	if(view)
	{
		AddChild(view);
		view->MakeFocus(true);
		ResizeTo(view->Bounds().Width(),view->Bounds().Height());
	}	
}

FlyoutWindow::~FlyoutWindow(void)
{
}

bool FlyoutWindow::QuitRequested(void)
{
	if(childview)
		RemoveChild(childview);
	fTarget->SetWindowNULL();
	return BWindow::QuitRequested();
}
