#include "QTView.h"
#include "FlyoutBox.h"
#include <Menu.h>
#include <MenuBar.h>
#include <MenuItem.h>

QTView::QTView(BRect frame, const char *name, int32 resize, int32 flags)
 : BView(frame,name,resize,flags)
{
	BRect r(Bounds());
	r.top=r.bottom-25;
	r.right++;
	r.bottom++;

	dockbay=new BView(r,"dockbay",B_FOLLOW_LEFT_RIGHT | B_FOLLOW_BOTTOM, B_WILL_DRAW);
	dockbay->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	AddChild(dockbay);

	r=Bounds();
	r.right=r.left+25;
	r.bottom-=26;
	
	
	toolbay=new BView(r,"toolbay",B_FOLLOW_TOP_BOTTOM | B_FOLLOW_LEFT,B_ITEMS_IN_COLUMN);
	toolbay->SetViewColor(192,192,255);
	AddChild(toolbay);
	
	r.Set(0,10,toolbay->Bounds().right-1,40);
	BMenuBar *menubar=new BMenuBar(r,NULL, B_FOLLOW_NONE, B_ITEMS_IN_COLUMN,false);
	toolbay->AddChild(menubar);
	menubar->SetBorder(B_BORDER_EACH_ITEM);
	
	BMenu *menu=new BMenu("Selecting", B_ITEMS_IN_COLUMN);
	menu->AddItem(new BMenuItem("Rectangle",NULL));
	menu->AddItem(new BMenuItem("Ellipse",NULL));
	menu->AddItem(new BMenuItem("Magic Wand",NULL));
	menu->AddItem(new BMenuItem("Lasso",NULL));
	menu->AddItem(new BMenuItem("Polygon Lasso",NULL));
	menu->AddItem(new BMenuItem("Smart Lasso",NULL));
	menubar->AddItem(menu);

	menu=new BMenu("Drawing", B_ITEMS_IN_COLUMN);
	menu->AddItem(new BMenuItem("Paintbrush",NULL));
	menu->AddItem(new BMenuItem("Pencil",NULL));
	menu->AddItem(new BMenuItem("Charcoal",NULL));
	menu->AddItem(new BMenuItem("Chalk",NULL));
	menu->AddItem(new BMenuItem("Airbrush",NULL));
	menu->AddItem(new BMenuItem("Eraser",NULL));
	menu->AddItem(new BMenuItem("Gradient",NULL));
	menu->AddItem(new BMenuItem("Stamp",NULL));
	menu->AddItem(new BMenuItem("Text",NULL));
	menubar->AddItem(menu);

	menu=new BMenu("Shape", B_ITEMS_IN_COLUMN);
	menu->AddItem(new BMenuItem("Line",NULL));
	menu->AddItem(new BMenuItem("Rectangle",NULL));
	menu->AddItem(new BMenuItem("Filled Rectangle",NULL));
	menu->AddItem(new BMenuItem("Ellipse",NULL));
	menu->AddItem(new BMenuItem("Filled Ellipse",NULL));
	menu->AddItem(new BMenuItem("Polygon",NULL));
	menu->AddItem(new BMenuItem("Bezier",NULL));
	menubar->AddItem(menu);

	menu=new BMenu("Retouching", B_ITEMS_IN_COLUMN);
	menu->AddItem(new BMenuItem("Clone",NULL));
	menu->AddItem(new BMenuItem("Smudge",NULL));
	menubar->AddItem(menu);

	menu=new BMenu("FilterTool", B_ITEMS_IN_COLUMN);
	menu->AddItem(new BMenuItem("Sharpen",NULL));
	menu->AddItem(new BMenuItem("Blur",NULL));
	menu->AddItem(new BMenuItem("Saturate",NULL));
	menu->AddItem(new BMenuItem("Desaturate",NULL));
	menu->AddItem(new BMenuItem("Dodge",NULL));
	menu->AddItem(new BMenuItem("Burn",NULL));
	menu->AddItem(new BMenuItem("Solarize",NULL));
	menu->AddItem(new BMenuItem("Posterize",NULL));
	menu->AddItem(new BMenuItem("Despeckle",NULL));
	menu->AddItem(new BMenuItem("ColorTweak",NULL));
	menubar->AddItem(menu);

	menu=new BMenu("Filters", B_ITEMS_IN_COLUMN);
	menu->AddItem(new BMenuItem("Sharpen",NULL));
	menu->AddItem(new BMenuItem("Blur",NULL));
	menu->AddItem(new BMenuItem("Saturate",NULL));
	menu->AddItem(new BMenuItem("Desaturate",NULL));
	menu->AddItem(new BMenuItem("Dodge",NULL));
	menu->AddItem(new BMenuItem("Burn",NULL));
	menu->AddItem(new BMenuItem("Solarize",NULL));
	menu->AddItem(new BMenuItem("Posterize",NULL));
	menu->AddItem(new BMenuItem("Despeckle",NULL));
	menu->AddItem(new BMenuItem("ColorTweak",NULL));
	menu->AddItem(new BMenuItem("Lens Flare",NULL));
	menu->AddItem(new BMenuItem("Find Edges",NULL));
	menu->AddItem(new BMenuItem("Pinch",NULL));
	menu->AddItem(new BMenuItem("Punch",NULL));
	menu->AddItem(new BMenuItem("Whirl",NULL));
	menu->AddItem(new BMenuItem("Clouds",NULL));
	menubar->AddItem(menu);

	menu=new BMenu("Other", B_ITEMS_IN_COLUMN);
	menu->AddItem(new BMenuItem("Color Selector",NULL));
	menu->AddItem(new BMenuItem("Zoom",NULL));
	menu->AddItem(new BMenuItem("Move",NULL));
	menubar->AddItem(menu);

	menubar->ResizeToPreferred();
	toolbay->ResizeTo(menubar->Bounds().Width(),toolbay->Bounds().Height());
	
	r=dockbay->Bounds();
	r.left=r.right-100;
	r.top++;
	r.OffsetBy(-200,0);
	
	FlyoutBox *fb=new FlyoutBox(r,"Flyout","Test Flyout");
	dockbay->AddChild(fb);

	r.Set(dockbay->Bounds().right-StringWidth("Main Menu")-20,dockbay->Bounds().top,
		dockbay->Bounds().right,dockbay->Bounds().bottom);
	menubar=new BMenuBar(r,NULL, B_FOLLOW_NONE, B_ITEMS_IN_ROW,false);

	menu=new BMenu("Main Menu", B_ITEMS_IN_COLUMN);

	BMenu *submenu=new BMenu("Help");
	submenu->AddItem(new BMenuItem("How do I...",NULL));
	submenu->AddItem(new BMenuItem("Table of Contents",NULL));
	menu->AddItem(submenu);
	
	submenu=new BMenu("Loaded Images");
	menu->AddItem(submenu);

	submenu=new BMenu("Scratchpad");
	submenu->AddItem(new BMenuItem("Copy Selection to Scratchpad",NULL,0,'C'));
	submenu->AddItem(new BMenuItem("Cut Selection to Scratchpad",NULL,0,'X'));
	submenu->AddItem(new BMenuItem("Copy from Scratchpad",NULL,0,'V'));
	submenu->AddItem(new BMenuItem("View Scratchpad",NULL));
	menu->AddItem(submenu);
	
	submenu=new BMenu("Selection");
	submenu->AddItem(new BMenuItem("Select All",NULL));
	submenu->AddItem(new BMenuItem("Invert",NULL));
	submenu->AddSeparatorItem();
	submenu->AddItem(new BMenuItem("Expand",NULL));
	submenu->AddItem(new BMenuItem("Shrink",NULL));
	submenu->AddSeparatorItem();
	submenu->AddItem(new BMenuItem("Select Color Range",NULL));
	submenu->AddItem(new BMenuItem("Load from Channel",NULL));
	submenu->AddSeparatorItem();
	submenu->AddItem(new BMenuItem("Hide",NULL));
	submenu->AddSeparatorItem();
	submenu->AddItem(new BMenuItem("Crop Image to Selection",NULL));
	menu->AddItem(submenu);

	submenu=new BMenu("Layer");
	submenu->AddItem(new BMenuItem("Hide",NULL));
	submenu->AddSeparatorItem();
	submenu->AddItem(new BMenuItem("Create New",NULL));
	submenu->AddItem(new BMenuItem("Create from File",NULL));
	submenu->AddItem(new BMenuItem("Delete",NULL));
	submenu->AddItem(new BMenuItem("Duplicate",NULL));
	submenu->AddSeparatorItem();
	submenu->AddItem(new BMenuItem("Transform",NULL));
	submenu->AddSeparatorItem();
	submenu->AddItem(new BMenuItem("Bring to Top",NULL));
	submenu->AddItem(new BMenuItem("Send to Bottom",NULL));
	submenu->AddItem(new BMenuItem("Move Up",NULL));
	submenu->AddItem(new BMenuItem("Move Down",NULL));
	submenu->AddSeparatorItem();
	submenu->AddItem(new BMenuItem("Properties",NULL));
	menu->AddItem(submenu);

	submenu=new BMenu("Image");
	submenu->AddItem(new BMenuItem("Create New",NULL));
	submenu->AddItem(new BMenuItem("Open",NULL));
	submenu->AddItem(new BMenuItem("[Open from Internet]",NULL));
	submenu->AddSeparatorItem();
	submenu->AddItem(new BMenuItem("Save",NULL));
	submenu->AddItem(new BMenuItem("Save As",NULL));
	submenu->AddItem(new BMenuItem("Save a Copy",NULL));
	submenu->AddSeparatorItem();
	submenu->AddItem(new BMenuItem("Close",NULL));
	submenu->AddItem(new BMenuItem("Close All",NULL));
	submenu->AddSeparatorItem();
	submenu->AddItem(new BMenuItem("Page Setup",NULL));
	submenu->AddItem(new BMenuItem("Print",NULL));
	submenu->AddSeparatorItem();
	submenu->AddItem(new BMenuItem("Transform",NULL));
	submenu->AddSeparatorItem();
	submenu->AddItem(new BMenuItem("Properties",NULL));
	menu->AddItem(submenu);

	submenu=new BMenu("Program");
	submenu->AddItem(new BMenuItem("About",NULL));
	submenu->AddItem(new BMenuItem("Settings",NULL));
	submenu->AddItem(new BMenuItem("Quit",NULL));
	menu->AddItem(submenu);

	menubar->AddItem(menu);

	dockbay->AddChild(menubar);
}

QTView::~QTView(void)
{
}

void QTView::Draw(BRect update)
{
}
